
require 'classes'

local vb = renoise.ViewBuilder()
local osc_client = OscClient("127.0.0.1", 8000, 2)

function the_gui()

  local buttons = vb:row { }

  for note_value = 0, 11 do

    local track = 1
    local instrument = 1
    local velocity = 100
    
    local button = vb:button {
      text = tostring(note_value),
      pressed = function()
          local stored_edit_mode = renoise.song().transport.edit_mode
          if stored_edit_mode then
              renoise.song().transport.edit_mode = false
          end
      
          osc_client:trigger_instrument(true, instrument, track, note_value, velocity)
  
          if stored_edit_mode then
            local timer_func
            timer_func = function()
                renoise.song().transport.edit_mode = true
                renoise.tool():remove_timer(timer_func)
              end
            renoise.tool():add_timer(timer_func, 40)
          end      
        end,
      released = function()
          osc_client:trigger_instrument(false, instrument, track, note_value, velocity)
        end,
    }
    buttons:add_child(button)
  end

  local vb_content = vb:row {
    buttons
  }

  local dialog = renoise.app():show_custom_dialog("Buttons", vb_content)

end

the_gui()
